using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using System.Data.Odbc;				// give us access to ODBC

public partial class Demo1 : System.Web.UI.Page
{
	static string connectionString = "DRIVER={MySQL ODBC 3.51 Driver};SERVER=oberon.cs.wisc.edu;PORT=3400;DATABASE=cs640_39;USER=cs640_39;PASSWORD=651560;OPTION=3;";
	OdbcConnection connection = new OdbcConnection(connectionString);

	protected override void OnInit(EventArgs e)
	{
		base.OnInit(e);
		try
		{
			connection.Open();
		}
		catch (Exception error)		// Crude example of how one might handle error checking on a page.
		{
			Response.Write("Something bad has happened while trying to open the database connection.<br/>");
			Response.Write(error.Message);
			Response.Write("<br/>");
			Response.End();
		}
	}

	protected override void OnUnload(EventArgs e)
	{
		base.OnUnload(e);
		if (connection.State == ConnectionState.Open)
			connection.Close();
	}

	protected void Page_Load(object sender, EventArgs e)
    {
		lblTotalNumberofStudents.Text = GetTotalNumberOfStudents();
		GenerateStateSummaryTable();
    }

	private string GetTotalNumberOfStudents()
	{
		OdbcCommand command = new OdbcCommand("select count(*) from people;", connection);
		return command.ExecuteScalar().ToString();
	}

	private void GenerateStateSummaryTable()
	{
		OdbcCommand command = new OdbcCommand("select count(state),state from people group by state order by state;", connection);
		OdbcDataReader reader = command.ExecuteReader();

		tblStatesTable.Width = new Unit(100);

		// Create table header
		TableRow row = new TableRow();

		TableCell cell = new TableCell();
		cell.Text = "State";
		cell.Font.Bold = true;
		row.Cells.Add(cell);

		cell = new TableCell();
		cell.Text = "Count";
		cell.Font.Bold = true;
		cell.HorizontalAlign = HorizontalAlign.Right;
		row.Cells.Add(cell);

		tblStatesTable.Rows.Add(row);

		// Create the table contents
		while (reader.Read())
		{
			row = new TableRow();

			cell = new TableCell();
			LinkButton link = new LinkButton();
			link.Text = reader[1].ToString();
			link.PostBackUrl = string.Format("demo2.aspx?state={0}", reader[1].ToString());
			cell.Controls.Add(link);
			row.Cells.Add(cell);

			cell = new TableCell();
			cell.Text = reader[0].ToString();
			cell.HorizontalAlign = HorizontalAlign.Right;
			row.Cells.Add(cell);

			tblStatesTable.Rows.Add(row);
		}
	}
}
