using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.Odbc;
using System.Collections.Generic;


public partial class Demo2 : System.Web.UI.Page
{
	static string connectionString = "DRIVER={MySQL ODBC 3.51 Driver};SERVER=oberon.cs.wisc.edu;PORT=3400;DATABASE=cs640_39;USER=cs640_39;PASSWORD=651560;OPTION=3;";
	OdbcConnection connection = new OdbcConnection(connectionString);

	protected override void OnInit(EventArgs e)
	{
		base.OnInit(e);
		try
		{
			connection.Open();
		}
		catch (Exception error)		// Crude example of how one might handle error checking on a page.
		{
			Response.Write("Something bad has happened while trying to open the database connection.<br/>");
			Response.Write(error.Message);
			Response.Write("<br/>");
			Response.End();
		}
	}

	protected override void OnUnload(EventArgs e)
	{
		base.OnUnload(e);
		if (connection.State == ConnectionState.Open)
			connection.Close();
	}


    protected void Page_Load(object sender, EventArgs e)
    {
		string state = Request.QueryString["state"];

		if (state == null)
		{
			Response.Write("No state argument found in the query string. Did you come to this page directly?<br/>");
			Response.End();
		}
		if (!IsPostBack)
		{
			PopulateStudentSelection(state);
		}
		else
		{
			if (ddlStudents.SelectedIndex > 0)
			{
				string studentid = ddlStudents.SelectedValue;
				string name = ddlStudents.SelectedItem.Text;
				spanSelectionBlock.Visible = false;
				List<string> grades = GenerateStudentRecord(studentid, name);
				GenerateGPA(grades);
			}
		}
    }

	private void GenerateGPA(List<string> grades)
	{
		// Assumes the number of credits (weight in the average) is the same for all courses.

		double sum = 0.0;
		int divisor = 0;
		Dictionary<string, double> letterGradeToNumericValue = new Dictionary<string, double>();

		letterGradeToNumericValue.Add("A", 4);
		letterGradeToNumericValue.Add("AB", 3.5);
		letterGradeToNumericValue.Add("B", 3);
		letterGradeToNumericValue.Add("BC", 2.5);
		letterGradeToNumericValue.Add("C", 2);
		letterGradeToNumericValue.Add("CD", 1.5);
		letterGradeToNumericValue.Add("D", 1);
		letterGradeToNumericValue.Add("F", 0);

		foreach (string grade in grades)
		{
			sum += letterGradeToNumericValue[grade];
			divisor++;
		}
		if (divisor > 0)
		{
			TableRow row = new TableRow();

			TableCell cell = new TableCell();
			cell.ColumnSpan = 5;
			cell.HorizontalAlign = HorizontalAlign.Right;
			cell.Text = string.Format("GPA: {0:0.00}", sum / divisor);
			row.Cells.Add(cell);
			tblStudentRecord.Rows.Add(row);
		}
	}

	private List<string> GenerateStudentRecord(string studentid, string name)
	{
		List<string> grades = new List<string>();
		tblStudentRecord.Visible = true;

		TableRow row = new TableRow();

		TableCell cell = new TableCell();
		cell.ColumnSpan = 5;
		cell.Text = "Student Record for " + name;
		cell.HorizontalAlign = HorizontalAlign.Center;
		row.Cells.Add(cell);
		tblStudentRecord.Rows.Add(row);

		OdbcCommand command = new OdbcCommand("select grade,semester,year,catalognumber,name from grades,courses where id = courseid and studentid = ? order by year,semester", connection);
		command.Parameters.AddWithValue("@studentid", studentid);

		OdbcDataReader reader = command.ExecuteReader();

		while (reader.Read())
		{
			row = new TableRow();

			cell = new TableCell();
			cell.Text = reader[2].ToString();
			row.Cells.Add(cell);

			cell = new TableCell();
			cell.Text = reader[1].ToString();
			row.Cells.Add(cell);

			cell = new TableCell();
			cell.Text = reader[3].ToString();
			row.Cells.Add(cell);

			cell = new TableCell();
			cell.Text = reader[4].ToString();
			row.Cells.Add(cell);

			cell = new TableCell();
			cell.Text = reader[0].ToString();
			cell.HorizontalAlign = HorizontalAlign.Right;
			row.Cells.Add(cell);

			grades.Add(reader[0].ToString());

			tblStudentRecord.Rows.Add(row);
		}
		reader.Close();
		return grades;
	}

	private void PopulateStudentSelection(string state)
	{
		ddlStudents.Items.Add(new ListItem("Make selection...", ""));
		OdbcCommand command = new OdbcCommand("select firstname,lastname,id from people where state like ? order by lastname;", connection);
		command.Parameters.AddWithValue("@state", state);
		OdbcDataReader reader = command.ExecuteReader();

		while (reader.Read())
		{
			ddlStudents.Items.Add(new ListItem(string.Format("{0}, {1}", reader[1].ToString(), reader[0].ToString()), reader[2].ToString()));
		}
		reader.Close();
	}
}
